import { ITaggable, TagManager } from "aws-cdk-lib";
import * as dynamodb from "aws-cdk-lib/aws-dynamodb";
import * as iam from "aws-cdk-lib/aws-iam";
import * as s3 from "aws-cdk-lib/aws-s3";
import { Construct } from "constructs";
export interface DataPipelineRestoreOptions {
    readonly pipelineName?: string;
    readonly dynamoDbThroughputRatio?: number;
    readonly logsBucket?: s3.IBucket;
}
export interface DataPipelineRestoreProps extends DataPipelineRestoreOptions {
    readonly table: dynamodb.ITable;
    readonly restoreBucket: s3.IBucket;
    readonly restoreFolder: string;
}
export declare class DataPipelineRestore extends Construct implements ITaggable {
    /**
     * The role used by datapipelines service.
     */
    readonly role: iam.IRole;
    /**
     * The role used by the emr cluster resources.
     */
    readonly resourceRole: iam.IRole;
    /**
     * The instance profile of the emr cluster resources.
     */
    readonly instanceProfile: iam.CfnInstanceProfile;
    readonly tags: TagManager;
    constructor(scope: Construct, id: string, props: DataPipelineRestoreProps);
}
